/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.wahlbeteiligung.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class WahlbeteiligungAuswertungTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.util.Date datum;
    public java.util.Date getDatum(){
      return datum;
    }

  public WahlbeteiligungAuswertungTK(
java.util.Date datum
  ) {
    super();


      this.datum = datum;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((datum == null) ? 0 : datum.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof WahlbeteiligungAuswertungTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        WahlbeteiligungAuswertungTK other = (WahlbeteiligungAuswertungTK) obj;

                if (datum == null) {
          if (other.datum != null) {
            return false;
          }
        } else if (!datum.equals(other.datum)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return WahlbeteiligungAuswertungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(WahlbeteiligungAuswertungConstants.MESSAGE_KEY_ENTITY_EINZAHL, WahlbeteiligungAuswertungConstants.MESSAGE_KEY_DATUM_EINZAHL, datum));
        
        return result;
      }


            @Override
            public String toString() {
            return "WahlbeteiligungAuswertungTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"datum="+datum
                        
            ;
                            return result;
            
            }
  
  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
    + messages.getMessageForMessageKey(WahlbeteiligungAuswertungConstants.MESSAGE_KEY_DATUM_EINZAHL) + "=" + datum
                + "]"

            ;
  }

            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends WahlbeteiligungAuswertung> java.util.Map<WahlbeteiligungAuswertungTK, E> mappeWahlbeteiligungAuswertungNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(WahlbeteiligungAuswertung::getWahlbeteiligungAuswertungTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<WahlbeteiligungAuswertung, WahlbeteiligungAuswertungTK> getWahlbeteiligungAuswertungToTKFunction() {
                return WahlbeteiligungAuswertung::getWahlbeteiligungAuswertungTK;
                }

}
